//---------------------------------------------------------------------------
// AdvConfigFormUnit.cpp
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Header Guard
#ifndef AdvConfigFormUnitH
#define AdvConfigFormUnitH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Application Includes
#include <IniFiles.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
class TAdvConfigForm : public TForm
{
__published:	// IDE-managed Components
	TButton *ButtonOk;
	TLabel *Label1;
	TRichEdit *RichEditHistory;
	TLabel *Label2;
	TRichEdit *RichEditVariables;
	TRadioGroup *RadioGroupCopyClipboard;
	TCheckBox *CheckBoxSwapCommas;
	void __fastcall ButtonOkClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
public:		// User declarations
	__fastcall TAdvConfigForm(TComponent* Owner);
public:
	bool LoadSettings();
	bool SaveSettings();
	void SettingsHaveChanged();
protected:
	bool LoadConfigIni(TMemIniFile *ini);
	bool SaveConfigIni(TMemIniFile *ini);
protected:
	int FindReplaceField(AnsiString &str,AnsiString findstr,AnsiString repstr);
public:
	void SetPersistantVariablesFromRichEdit();
	void SetRichEditFromParserVariables();
public:
	int get_clipcopymode() {return RadioGroupCopyClipboard->ItemIndex;};
};
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// C++ Builder Global Instance Pointer
extern PACKAGE TAdvConfigForm *AdvConfigForm;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// End of Header Guard
#endif
//---------------------------------------------------------------------------

