//-----------------------------------------------------------------------
// JrPlugin_MyPlugin
//-----------------------------------------------------------------------


//---------------------------------------------------------------------------
// Header Guard
#ifndef JrPlugin_MyPluginH
#define JrPlugin_MyPluginH
//---------------------------------------------------------------------------



//------------------------------------------------------------------------
// system includes
#include <vcl.h>
#include <windows.h>
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// includes generic plugin shell of other headers
#include "JrPlugin_GenericShell.h"
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// Inlcude FARR SPECIFIC plugin func definitions (shared with host)
#include "JrPluginFuncs_FARR.h"
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//this plugin uses the JrFirefoxBookmarks class
//#include "JrCalcFuncs.h"
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// C++ Builder Stuff
#pragma hdrstop
//-----------------------------------------------------------------------


















//-----------------------------------------------------------------------
// Plugin defines refered to in JrPlugin_GenericShell.cpp
// IMPORTANT: you need to customize there
//
#define ThisPlugin_DisplayName			"FCalc"
#define ThisPlugin_VersionString		"1.10.01"
#define ThisPlugin_ReleaseDateString		"June 28th, 2008"
#define ThisPlugin_Author			"mouser <mouser@donationcoder.com>"
#define ThisPlugin_HomepageURL			"http://www.donationcoder.com/Software/Mouser/findrun/index.html"
#define ThisPlugin_UpdateURL			""
#define ThisPlugin_ShortDescription		"Calculate mathematical expressions from within FARR."
#define ThisPlugin_LongDescription		"This plugin will let you calculate numerical expressions. Built with muParser (http://muparser.sourceforge.net/)"
#define ThisPlugin_About			ThisPlugin_LongDescription
#define ThisPlugin_StatusBar			"FCalc plugin by mouser (powered by muParser)."
//
// If you support advanced options button, specify caption here, otherwise ""
#define ThisPlugin_AdvConfigString		"Advanced Options"
//
// If you support a read me file or help file, specify caption here, otherwise ""
#define ThisPlugin_ReadMeString			"View Help File"
// Used internally to display help file
#define ThisPlugin_ReadMeFile			"README.txt"
//
// If this plugin has an icon (recommended), specify icon file in same dir as dll - shown in plugin list
#define ThisPlugin_IconFilename			"FCalc.ico"
//
//-----------------------------------------------------------------------






















//-----------------------------------------------------------------------
// FARR specific stuff
#define ThisPlugin_FARR_DefaultAlias		""
#define ThisPlugin_FARR_DefaultRegex		"^fc (.*)$|^fc$"
#define ThisPlugin_FARR_DefaultRegexFilter	"$$1"
#define ThisPlugin_FARR_DefaultKeywordStr	""
#define ThisPlugin_FARR_DefaultScoreStr		"999"
//-----------------------------------------------------------------------






//-----------------------------------------------------------------------
// external globals defined in the .cpp
extern E_SearchStateT current_searchstate;
extern E_ResultAvailableStateT resultsavailabletype;
extern int numresultsavailable;
extern BOOL current_lockstate;
extern bool isready;
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// FARR: global callback when we want to tell host our search state has changed asynchronously
extern Fp_GlobalPluginCallback_NotifySearchStateChanged callbackfp_notifysearchstatechanged;
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// Forward declarations
void ExecuteCallback_SearchStateChanged();
BOOL DoFarrSearchBegin(const char *expressionstring, int triggermethod);
void EvaluateAndShow(AnsiString expressionstr, int triggermethod);
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// Our plugin-specific functions called by generic plugin shell
BOOL MyPlugin_DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved);
//
BOOL MyPlugin_DoInit();
BOOL MyPlugin_DoShutdown();
BOOL MyPlugin_GetStrVal(const char* varname,char *destbuf, int maxlen);
BOOL MyPlugin_SetStrVal(const char* varname, void *val);
BOOL MyPlugin_SupportCheck(const char* testname, int version);
BOOL MyPlugin_DoAdvConfig();
BOOL MyPlugin_DoShowReadMe();
BOOL MyPlugin_SetState(int newstateval);
//-----------------------------------------------------------------------



//---------------------------------------------------------------------------
void AddLastEvalToHistory(bool revaluate);
void ClearCalcHistory();
void CopyToClipboard(AnsiString txt);
bool HandleSpecialExpressions(AnsiString &expressionstr, int triggermethod);
void ClearVariables(AnsiString variableliststr);
void ListVariables();
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
bool JrLeftStringSplit(AnsiString &mainstr,AnsiString &leftword, const AnsiString &splitstr, bool dotrim);
//---------------------------------------------------------------------------


//-----------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------


