//---------------------------------------------------------------------------
#pragma hdrstop
#include "muparser_myextensions.h"
#include <string.h>
//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// these are from an email to me from Questor / Fused <questor@fused.de>

bool isBinVal(const char *a_szExpr, int &a_iPos, double &a_fVal) {
	if(strlen(a_szExpr)<2 || a_szExpr[0] != '$' || a_szExpr[1] != 'b')
		return false;

	unsigned iVal = 0, iBits = sizeof(iVal)*8;
	unsigned i=1;
	for (; (a_szExpr[i+1]=='0' || a_szExpr[i+1]=='1') && i<iBits; ++i)
		iVal |= (int)(a_szExpr[i+1]=='1') << ((iBits-1)-i);

	if (i==0)
		return false;

	if (i==iBits)
		return false;

	a_fVal = (unsigned)(iVal >> (iBits-i) );
	a_iPos += i+1;

	return true;
}



bool isHexVal(const char *a_szExpr, int &a_iPos, double &a_fVal) {
	if(strlen(a_szExpr)<2 || a_szExpr[0] != '$' || a_szExpr[1] != 'x')
        return false;
   
    unsigned maxNumNibbles = 8;
    int value = 0;
    unsigned i;
    for(i=1; ((a_szExpr[i+1]>='0'&&a_szExpr[i+1]<='9') ||
			  (a_szExpr[i+1]>='A'&&a_szExpr[i+1]<='F') ||
			  (a_szExpr[i+1]>='a'&&a_szExpr[i+1]<='f')    ) && i<=maxNumNibbles; ++i) {
		value<<=4;
		if(a_szExpr[i+1]>='0' && a_szExpr[i+1]<='9') {
			value += a_szExpr[i+1]-'0';
		} else if(a_szExpr[i+1]>='A' && a_szExpr[i+1]<='F') {
			value += 10+a_szExpr[i+1]-'A';
		} else if(a_szExpr[i+1]>='a' && a_szExpr[i+1]<='f') {
			value += 10+a_szExpr[i+1]-'a';
		}
	}
	if(i==0)
		return false;
	if(i==maxNumNibbles+1)
		return false;

	a_fVal = (double)value;
	a_iPos += i+1;

	return true;
}

//---------------------------------------------------------------------------
