//---------------------------------------------------------------------------
// AdvConfigFormUnit.cpp
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// System includes and C++ Builder Stuff
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Application includes
#include "JrPlugin_MyPlugin.h"
#include "AdvConfigFormUnit.h"
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// C++ Builder stuff
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// include main debug header
#include "jrdebug.h"
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Global Form Instance Pointer
TAdvConfigForm *AdvConfigForm=NULL;
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
__fastcall TAdvConfigForm::TAdvConfigForm(TComponent* Owner)
	: TForm(Owner)
{
	// nothing to do in constructor
}
//---------------------------------------------------------------------------


//-----------------------------------------------------------------------
void __fastcall TAdvConfigForm::ButtonOkClick(TObject *Sender)
{
	SettingsHaveChanged();
	Close();
}
//---------------------------------------------------------------------------



//-----------------------------------------------------------------------
void __fastcall TAdvConfigForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	// let's try just closing

	// always save settings when we close - if we were open
	debugout << "FarrFoxx FormClose - stage 1";
	debugout << "FarrFoxx FormClose - stage 2";

	//SaveSettings();
	debugout << "FarrFoxx FormClose - stage 3";
	// free bookmarks so they will be reloaded?
	//gbookmarkmanagerp->FreeAllBookmarks();

	// hide
	Action=caHide;
	Hide();
}
//---------------------------------------------------------------------------









//-----------------------------------------------------------------------
bool TAdvConfigForm::SaveSettings()
{
	// save adv options to file
      	debugout << "FarrFoxx SaveSettings - stage 1";

	bool bretv=false;
	AnsiString appdir=AnsiString(dlldir);
	AnsiString filename=appdir+"advoptions.cfg";
	AnsiString filenametemp=filename+".tmp";

	// open temp ini file
        TMemIniFile *ini;
        ini = new TMemIniFile(filenametemp);
        if (!ini)
                return false;

      	debugout << "FarrFoxx SaveSettings - stage 2";

	// save settings to temp file
	try
		{
		// save info
		bretv=SaveConfigIni(ini);
	      	debugout << "FarrFoxx SaveSettings - stage 3";
		}
	catch (...)
		{
		// MyShowMessage("Error loading "+AnsiString(ThisPlugin_DisplayName)+" plugin configuration file '"+filename+"'.");
	      	debugout << "FarrFoxx SaveSettings - stage 4";
		}

      	debugout << "FarrFoxx SaveSettings - stage 5";

	ini->UpdateFile();

	// close ini
	delete ini;

      	debugout << "FarrFoxx SaveSettings - stage 6";

	// ok success, so now copy it over the real existing settings file
	if (bretv && FileExists(filenametemp))
		{
		if (FileExists(filename))
			{
			// make backup
		      	debugout << "FarrFoxx SaveSettings - stage 7";
			if (FileExists(filename+".bak"))
				DeleteFile((filename+".bak").c_str());
			CopyFile(filename.c_str(),(filename+".bak").c_str(),true);
			DeleteFile(filename.c_str());
		      	debugout << "FarrFoxx SaveSettings - stage 8";
			}
	      	debugout << "FarrFoxx SaveSettings - stage 9";
		RenameFile(filenametemp.c_str(),filename.c_str());
	      	debugout << "FarrFoxx SaveSettings - stage 10";
		}

      	debugout << "FarrFoxx SaveSettings - stage 11";

	// success
	return bretv;
}


bool TAdvConfigForm::SaveConfigIni(TMemIniFile *ini)
{
	// load ini stuff

      	debugout << "FarrFoxx SaveConfigIni - stage 1";

	ini->WriteString("Information","File Identification",AnsiString(ThisPlugin_DisplayName));
	ini->WriteString("Information","Version",AnsiString(ThisPlugin_VersionString));
	//
      	debugout << "FarrFoxx SaveConfigIni - stage 2";
	AnsiString ltext=MemoCustomBookmarkFiles->Lines->Text;
      	debugout << "FarrFoxx SaveConfigIni - stage 3";
	// fixup
	FindReplaceField(ltext,"\r\n","\\r\\n");
      	debugout << "FarrFoxx SaveConfigIni - stage 4";
	ini->WriteString("Settings","MemoCustomBookmarkFiles",ltext);
      	debugout << "FarrFoxx SaveConfigIni - stage 5";
	//
	ini->WriteBool("Settings","CheckBoxBrowserFireFox",CheckBoxBrowserFireFox->Checked);
	ini->WriteBool("Settings","CheckBoxBrowserOpera",CheckBoxBrowserOpera->Checked);
	ini->WriteBool("Settings","CheckBoxBrowserIE",CheckBoxBrowserIE->Checked);
	ini->WriteBool("Settings","CheckBoxIncludeFolderInTitle",CheckBoxIncludeFolderInTitle->Checked);
	ini->WriteBool("Settings","CheckBoxRescanRegularly",CheckBoxRescanRegularly->Checked);

      	debugout << "FarrFoxx SaveConfigIni - stage 6";

	// success
	return true;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
bool TAdvConfigForm::LoadSettings()
{
	// load adv options from file
      	debugout << "FarrFoxx LoadSettings - stage 1";

	bool bretv=false;
	AnsiString appdir=AnsiString(dlldir);
	AnsiString filename=appdir+"advoptions.cfg";

	if (!FileExists(filename))
		return false;

      	debugout << "FarrFoxx LoadSettings - stage 2";

        TMemIniFile *ini;
        ini = new TMemIniFile(filename);
        if (!ini)
        	{
		// file not found
                return false;
                }

      	debugout << "FarrFoxx LoadSettings - stage 3";

	// load settings
	try
		{
		// load info
		AnsiString version;
		version=ini->ReadString("Information","File Identification","");
		if (version!=AnsiString(ThisPlugin_DisplayName))
			{
			ShowMessage("Error: "+filename+" is not a configuration file for this plugin. Please delete it if this problem persists.");
			}
		else
			{
		      	debugout << "FarrFoxx LoadSettings - stage 4";
			bretv=LoadConfigIni(ini);
			}
		}
	catch (...)
		{
	      	debugout << "FarrFoxx LoadSettings - stage 5";
		ShowMessage("Error loading "+AnsiString(ThisPlugin_DisplayName)+" plugin configuration file '"+filename+"'.");
		}

      	debugout << "FarrFoxx LoadSettings - stage 6";

	// close ini
	delete ini;

	// success
	return bretv;
}


bool TAdvConfigForm::LoadConfigIni(TMemIniFile *ini)
{
	// load ini stuff
      	debugout << "FarrFoxx LoadConfigIni - stage 1";
	AnsiString FileVersion=ini->ReadString("Information","Version","");
	//
	AnsiString ltext=ini->ReadString("Settings","MemoCustomBookmarkFiles","");
	// fixup
      	debugout << "FarrFoxx LoadConfigIni - stage 2";
	FindReplaceField(ltext,"\\r\\n","\r\n");
      	debugout << "FarrFoxx LoadConfigIni - stage 3";
	MemoCustomBookmarkFiles->Lines->Text=ltext;
      	debugout << "FarrFoxx LoadConfigIni - stage 4";
	//
	CheckBoxBrowserFireFox->Checked=ini->ReadBool("Settings","CheckBoxBrowserFireFox",CheckBoxBrowserFireFox->Checked);
	CheckBoxBrowserOpera->Checked=ini->ReadBool("Settings","CheckBoxBrowserOpera",CheckBoxBrowserOpera->Checked);
	CheckBoxBrowserIE->Checked=ini->ReadBool("Settings","CheckBoxBrowserIE",CheckBoxBrowserIE->Checked);
	CheckBoxIncludeFolderInTitle->Checked=ini->ReadBool("Settings","CheckBoxIncludeFolderInTitle",CheckBoxIncludeFolderInTitle->Checked);
	CheckBoxRescanRegularly->Checked=ini->ReadBool("Settings","CheckBoxRescanRegularly",CheckBoxRescanRegularly->Checked);

      	debugout << "FarrFoxx LoadConfigIni - stage 5";

	// success
	return true;
}
//-----------------------------------------------------------------------





//-----------------------------------------------------------------------
void TAdvConfigForm::SettingsHaveChanged()
{
	// settings have changed, now deal with it
      	debugout << "FarrFoxx SettingsHaveChanged";

	gbookmarkmanagerp->Set_BrowserEnable_FireFox(CheckBoxBrowserFireFox->Checked);
	gbookmarkmanagerp->Set_BrowserEnable_Opera(CheckBoxBrowserOpera->Checked);
	gbookmarkmanagerp->Set_BrowserEnable_IE(CheckBoxBrowserIE->Checked);
	gbookmarkmanagerp->Set_FolderInTitle(CheckBoxIncludeFolderInTitle->Checked);
	gbookmarkmanagerp->Set_RescanRegularly(CheckBoxRescanRegularly->Checked);
	SaveSettings();
}
//-----------------------------------------------------------------------




//---------------------------------------------------------------------------
int TAdvConfigForm::FindReplaceField(AnsiString &str,AnsiString findstr,AnsiString repstr)
{
      	debugout << "FarrFoxx FindReplaceField - stage 1";
	int len=findstr.Length();
	int slen=str.Length();
	int pos;
	int replacements=0;
	for (;;)
		{
		pos=str.Pos(findstr);
		if (pos<=0)
			break;
		str=str.SubString(1,pos-1)+repstr+str.SubString(pos+len,(slen-(pos+len))+1);
		slen=str.Length();
		++replacements;
		}
      	debugout << "FarrFoxx FindReplaceField - stage 2";
	return replacements;
}
//---------------------------------------------------------------------------



//-----------------------------------------------------------------------
void TAdvConfigForm::LoadCustomBookmarks()
{
	// load custom bookmarks from files in memo
		debugout << "FarrFoxx LoadCustomBookmarks - stage 1";
	int lcount = MemoCustomBookmarkFiles->Lines->Count;
	AnsiString fname;
	for (int i=0;i<lcount;++i)
		{
		fname=MemoCustomBookmarkFiles->Lines->Strings[i];
		if (FileExists(fname))
			gbookmarkmanagerp->LoadAllBookmarksInFile(fname.c_str());
		if (DirectoryExists(fname))
			gbookmarkmanagerp->LoadAllBookmarksInFolder(fname.c_str());
		}
		debugout << "FarrFoxx LoadCustomBookmarks - stage 2";
}
//-----------------------------------------------------------------------









