//---------------------------------------------------------------------------
// JRbcbConfigCollection
//  manage a set of config files in a menu
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#ifndef JRConfigCollectionH
#define JRConfigCollectionH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <string>
#include <vector>
//
#include "JRrfilefinder.h"
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
class ConfigEntry
{
friend class JrConfigManager;
protected:
	std::string LabelString;
	std::string FileName;
	bool isDupeLabel;
protected:
	ConfigEntry(std::string in_FileName,bool relativenicelabelflag,std::string  BaseDirectory);
public:
	std::string get_LabelString() {return LabelString;};
	std::string get_FileName() {return FileName;};
	void set_isDupeLabel(bool val) {isDupeLabel=val;};
	bool get_isDupeLabel() {return isDupeLabel;};
public:
	static std::string MakeLabelFromFileName(std::string fullfilename,bool relativenicelabelflag,std::string  BaseDirectory);
};
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
class JrConfigManager
{
protected:
	std::vector<ConfigEntry*> ConfigEntries;
	std::string FileMask;
	std::string BaseDirectory;
	bool relativenicelabelflag;
public:
	JrConfigManager() {relativenicelabelflag=false;};
	~JrConfigManager() {;};
public:
	void Clear();
	void RescanForFiles();
public:
	void set_FileMask(std::string val) {FileMask=val;};
	void set_BaseDirectory(std::string val) {BaseDirectory=val;};	
public:
	// callback for discovering files
	bool AddAFile(std::string fullfilename);
public:
	ConfigEntry* get_Entry(int index) {return ConfigEntries[index];};
	int get_EntryCount() {return ConfigEntries.size();};
public:
	bool IsLabelDuped(ConfigEntry* entryp);
public:
	void set_relativenicelabelflag(bool val) {relativenicelabelflag=val;};
public:
	int FindEntryIndexByFileName(std::string fullfilename);
};
//---------------------------------------------------------------------------




















//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
