//---------------------------------------------------------------------------
// JRrfilefinder
//  templated callback recursive file finder
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#ifndef JRrfilefinderH
#define JRrfilefinderH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <string>
#include <windows.h>
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// templated global function
template <class T>
void RecursiveFileFinder(T* objectp,std::string directory, const std::string &filefilterstring, bool recursive);
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
template <class T>
void RecursiveFileFinder(T* objectp,std::string directory, const std::string &filefilterstring, bool recursive)
{
	// This method recursively searches the directory specified by the parameter and all
	// of its subdirectories (if recursive set).
	// The directory name is assumed to end with a backslash.
	std::string fullfilename;
	WIN32_FIND_DATA filedata;  // Structure for file data
	HANDLE filehandle;         // Handle for searching
	//HANDLE badhandle=INVALID_HANDLE_VALUE;
	HANDLE badhandle=(HANDLE)-1;

	if (directory.length()>0)
		{
		// trim final slash
		if (directory[directory.length()-1]=='\\')
			directory=directory.substr(0,directory.length()-1);
		}

	// Search files
	filehandle = FindFirstFile ((directory+ "\\"+filefilterstring).c_str (), &filedata) ;
	if (filehandle != badhandle)
		{
		do
			{
			if ((filedata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
				// Directory
				continue;
				}
			else
				{
				// CALLBACK -> Add file to object
				objectp->AddAFile(directory+"\\"+filedata.cFileName);
				}
			} while (FindNextFile (filehandle, &filedata));
		FindClose (filehandle);
		}

	// Search subdirectories
	filehandle = FindFirstFile ((directory+ "\\*.*").c_str (), &filedata) ;
	if (filehandle != badhandle)
		{
		do
			{
			if ((filedata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
				// Directory
				if (recursive && strcmp(filedata.cFileName,".")!=0 && strcmp(filedata.cFileName,"..")!=0)
					{
					// Recursive call here
					if (strcmp(filedata.cFileName,"Junk")==0)
						;
					else if (strcmp(filedata.cFileName,"Old")==0)
						;
					else if (strcmp(filedata.cFileName,"Disabled")==0)
						;
					else if (strstr(filedata.cFileName,"backup")!=NULL)
						;
					else
						RecursiveFileFinder(objectp,directory+"\\"+filedata.cFileName,filefilterstring,true);
					}
				}
			} while (FindNextFile (filehandle, &filedata));
		FindClose (filehandle);
		}

  	// done searching
}
//---------------------------------------------------------------------------




















//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
