//-----------------------------------------------------------------------
// JrPlugin_MyPlugin
//-----------------------------------------------------------------------


//---------------------------------------------------------------------------
// Header Guard
#ifndef JrPlugin_MyPluginH
#define JrPlugin_MyPluginH
//---------------------------------------------------------------------------



//------------------------------------------------------------------------
// system includes
#include <vcl.h>
#include <windows.h>
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// includes generic plugin shell of other headers
#include "JrPlugin_GenericShell.h"
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// Inlcude FARR SPECIFIC plugin func definitions (shared with host)
#include "JrPluginFuncs_FARR.h"
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//this plugin uses the JrFirefoxBookmarks class
#include "JrBookmarkManager.h"
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// C++ Builder Stuff
#pragma hdrstop
//-----------------------------------------------------------------------


















//-----------------------------------------------------------------------
// Plugin defines refered to in JrPlugin_GenericShell.cpp
// IMPORTANT: you need to customize there
//
#define ThisPlugin_DisplayName			"FarrFox"
#define ThisPlugin_VersionString		"1.09.01"
#define ThisPlugin_ReleaseDateString		"July 25th, 2008"
#define ThisPlugin_Author			"mouser <mouser@donationcoder.com>"
#define ThisPlugin_HomepageURL			"http://www.donationcoder.com/Software/Mouser/findrun/index.html"
#define ThisPlugin_UpdateURL			""
#define ThisPlugin_ShortDescription		"Search your FireFox bookmarks from within FARR."
#define ThisPlugin_LongDescription		"This plugin will let you search your firefox bookmarks.  It was inspired by (but doesn't use code from) the Foxy plugin written for Launchy by Josh Karlin."
//
// If you support advanced options button, specify caption here, otherwise ""
#define ThisPlugin_AdvConfigString		"Advanced Options"
//
// If you support a read me file or help file, specify caption here, otherwise ""
#define ThisPlugin_ReadMeString			"View Help File"
// Used internally to display help file
#define ThisPlugin_ReadMeFile			"README.txt"
//
// If this plugin has an icon (recommended), specify icon file in same dir as dll - shown in plugin list
#define ThisPlugin_IconFilename			"firefox.ico"
//
//-----------------------------------------------------------------------






















//-----------------------------------------------------------------------
// FARR specific stuff
#define ThisPlugin_FARR_DefaultAlias		"ff"
#define ThisPlugin_FARR_DefaultRegex		"fff (.*)"
#define ThisPlugin_FARR_DefaultRegexFilter	"$$1"
#define ThisPlugin_FARR_DefaultKeywordStr	"bookmarks"
#define ThisPlugin_FARR_DefaultScoreStr		"300"
//-----------------------------------------------------------------------






//-----------------------------------------------------------------------
// external globals defined in the .cpp
extern E_SearchStateT current_searchstate;
extern E_ResultAvailableStateT resultsavailabletype;
extern int numresultsavailable;
extern BOOL current_lockstate;
extern JrBookmarkManagerT* gbookmarkmanagerp;
extern bool isready;
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// FARR: global callback when we want to tell host our search state has changed asynchronously
extern Fp_GlobalPluginCallback_NotifySearchStateChanged callbackfp_notifysearchstatechanged;
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// Forward declarations
void ExecuteCallback_SearchStateChanged();
void LoadBookmarksIfAppropriate(bool doforce);
void Special_ReloadBookmarksResetSearch();
BOOL DoFarrSearchBegin(const char *searchstring_lc_nokeywords);
void ShowAboutResult();
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// Our plugin-specific functions called by generic plugin shell
BOOL MyPlugin_DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved);
//
BOOL MyPlugin_DoInit();
BOOL MyPlugin_DoShutdown();
BOOL MyPlugin_GetStrVal(const char* varname,char *destbuf, int maxlen);
BOOL MyPlugin_SetStrVal(const char* varname, void *val);
BOOL MyPlugin_SupportCheck(const char* testname, int version);
BOOL MyPlugin_DoAdvConfig();
BOOL MyPlugin_DoShowReadMe();
BOOL MyPlugin_SetState(int newstateval);
//-----------------------------------------------------------------------





//-----------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------


