//---------------------------------------------------------------------------
// AdvConfigFormUnit.cpp
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Header Guard
#ifndef AdvConfigFormUnitH
#define AdvConfigFormUnitH

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Application Includes
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <IniFiles.hpp>
#include <Dialogs.hpp>
#include "hkClipboardMonitor.hpp"
#include "icSwavC.hpp"
#include <Mask.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
#define MAXLINELEN 9999
#define Def_SlashrReplacement "r"
#define Def_SlashnReplacement "n"
//---------------------------------------------------------------------------
class TAdvConfigForm : public TForm
{
__published:	// IDE-managed Components
	ThkClipboardMonitor *ClipboardMonitor;
	TGroupBox *grpRecordTextSettings;
	TListView *lvwClipboard;
	TLabel *lblMaxClips;
	TLabel *lblMaxLength;
	TMaskEdit *txtMaxLengthClips;
	TMaskEdit *txtMaxNumberClips;
	TCheckBox *chkPlaySound;
	TEdit *txtPlaySound;
	TicSwavC *WaveFile;
	TOpenDialog *ChooseSound;
	TButton *cmdBrowse;
	TButton *cmdStop;
	TButton *cmdStart;
	TButton *cmdClearAll;
	TButton *cmdClearSelected;
	TLabel *lblCalledFromKKPrefs;
	TMainMenu *MainMenu;
	TMenuItem *mnuFile;
	TMenuItem *mnuClearSelected;
	TMenuItem *mnuFileClearAll;
	TMenuItem *mnuFileClose;
	TLabel *lblTip;
	TLabel *lblRefreshClipboardMonitor;
	void __fastcall ClipboardMonitorChange(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall cmdBrowseClick(TObject *Sender);
	void __fastcall cmdStartClick(TObject *Sender);
	void __fastcall cmdStopClick(TObject *Sender);
	void __fastcall cmdClearSelectedClick(TObject *Sender);
	void __fastcall cmdClearAllClick(TObject *Sender);
	void __fastcall mnuClearSelectedClick(TObject *Sender);
	void __fastcall mnuFileClearAllClick(TObject *Sender);
	void __fastcall mnuFileCloseClick(TObject *Sender);
private:	// User declarations
        TReplaceFlags MyFlags; // For StringReplace lines of code.
        TListItem *ListItemToAdd; // For adding a listview item.
        AnsiString EntryData; // For Saving of the Klips.
        int Entries; // For Saving of the Klips.
	AnsiString ClipboardText; // String for Clipboard Text
        int ClipboardTextLength; // Length of Copied Klip Text
        int ClipLineLength; // Stores Max Length of Clipboard Text
        int FindItem; // For searching and deleting duplicates.
        int MaxEntries; // Stores the number of max entries.
        int DeleteSelected; // For clear selected entries.
        int NumLines; // Stores the current line number.
public:		// User declarations
	__fastcall TAdvConfigForm(TComponent* Owner);
public:
	bool LoadSettings();
	bool SaveSettings();
	void SettingsHaveChanged();
        void OpenKlipKeeperDataFileToEntries();
        void SaveEntriesToKlipKeeperDataFile();
protected:
	bool LoadConfigIni(TMemIniFile *ini);
	bool SaveConfigIni(TMemIniFile *ini);
protected:

};
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// C++ Builder Global Instance Pointer
extern PACKAGE TAdvConfigForm *AdvConfigForm;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// End of Header Guard
#endif
//---------------------------------------------------------------------------
