//---------------------------------------------------------------------------
// AdvConfigFormUnit.cpp
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Header Guard
#ifndef AdvConfigFormUnitH
#define AdvConfigFormUnitH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Application Includes
#include <IniFiles.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <CheckLst.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include "BrwsFldr.hpp"
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
#define BlankMessageString "To get started, press the Menu button, select \"Preferences\" and then choose which books to activate.\r\n\r\nThen just double-click the tray icon (or hit alt+W) whenever you want some wisdom."
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include "JRConfigCollection.h"
//
#include "JRutils_mini.h"
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
class TAdvConfigForm : public TForm
{
protected:
	AnsiString basedir,bookdir;
	long quote_activecount;
	JrConfigManager quotefiles;
	bool initialized;
__published:	// IDE-managed Components
	TButton *ButtonOk;
	TPageControl *PageControl1;
	TTabSheet *TabSheetBooks;
	TLabel *Label3;
	TCheckListBox *CheckListBoxBooks;
	TRichEdit *RichEditBookInfo;
	TTabSheet *TabSheetInternal;
	TCheckBox *CheckBoxFirstUse;
	TMemo *MemoDisabledBooks;
	TPopupMenu *PopupMenuBooks;
	TMenuItem *EditThisBookItem;
	TMenuItem *VisitWebpageforBookItem;
	TMenuItem *N1;
	TMenuItem *ExportthisBookInAnotherFormat1;
	TMenuItem *MenuItemExportMultilinePercents;
	TMenuItem *MenuItemExportSingleLines;
	TMenuItem *N2;
	TMenuItem *RescanBookDirectoryItem;
	TSaveDialog *SaveDialogExport;
	TEdit *EditBookDir;
	TSpeedButton *ButtonBrowseBookDir;
	TLabel *Label1;
	TLabel *Label2;
	TMyBrowseForFolder *MyBrowseForFolder;
	void __fastcall ButtonOkClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall EditThisBookItemClick(TObject *Sender);
	void __fastcall VisitWebpageforBookItemClick(TObject *Sender);
	void __fastcall MenuItemExportMultilinePercentsClick(TObject *Sender);
	void __fastcall MenuItemExportSingleLinesClick(TObject *Sender);
	void __fastcall RescanBookDirectoryItemClick(TObject *Sender);
	void __fastcall CheckListBoxBooksClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall ButtonBrowseBookDirClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TAdvConfigForm(TComponent* Owner);
public:
	void DoInitialize();
	void RandomizeInit();
	bool LoadSettings();
	bool SaveSettings();
	void SettingsHaveChanged();
protected:
	bool LoadConfigIni(TMemIniFile *ini);
	bool SaveConfigIni(TMemIniFile *ini);
protected:
	int FindReplaceField(AnsiString &str,AnsiString findstr,AnsiString repstr);
public:
	void ExportBook(bool userealnewlines,AnsiString separator);
	BookStore* get_selectedbookstorep();
//
public:
	BookStore* get_bookbyindex(int index) {ConfigEntry* entryp=quotefiles.get_Entry(index); if (entryp!=NULL) return entryp->get_bookstorep(); return NULL;};
	void ReScanBookDir();
	void SaveDisabledList();
	void DisableBooks();
	void RecalcQuoteCount();
	void FillBookChecklist();
	void CacheEnabledBookQuotes(bool forcereload);
public:
	void set_basedir(AnsiString str) {basedir=str;};
public:
	long GetActiveQuoteCount() {return quote_activecount;};
public:
	AnsiString GetQuoteByIndex(int index, BookStore* &bookstorep);
};
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// C++ Builder Global Instance Pointer
extern PACKAGE TAdvConfigForm *AdvConfigForm;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// End of Header Guard
#endif
//---------------------------------------------------------------------------

