//-----------------------------------------------------------------------
// JrPlugin_MyPlugin
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// System includes
#include <vcl.h>
#include <vcl\Clipbrd.hpp>
#include <windows.h>
#include <stdio.h>
#include <string>
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// BCB (Borland C++ Builder) Hint
#pragma hdrstop
//-----------------------------------------------------------------------







//-----------------------------------------------------------------------
// our partner header which includes the funcs we need in the right way
#include "JrPlugin_MyPlugin.h"
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// see JrPluginFuncs_FARR.h for function definitions we will be implementing here
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// BCB advanced configuration form
#include "AdvConfigFormUnit.h"
//-----------------------------------------------------------------------




//-----------------------------------------------------------------------
// global state info
E_SearchStateT current_searchstate=E_SearchState_Stopped;
E_ResultAvailableStateT resultsavailabletype=E_ResultAvailableState_None;
int numresultsavailable=0;
BOOL current_lockstate=FALSE;
bool isready=true;
//
// farr-specific function pointer so we can call to inform the host when we have results
Fp_GlobalPluginCallback_NotifySearchStateChanged callbackfp_notifysearchstatechanged=NULL;
//
AnsiString iconfile;
//-----------------------------------------------------------------------





































//-----------------------------------------------------------------------
// These functions are our plugin-specific versions of the generic
//  functions exported by the generic DLL shell.
// See JrPlugin_GenericShell.h and .cpp for descriptions of what these
//  functions are supposed to do.
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
BOOL MyPlugin_DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	switch (reason)
		{
		case DLL_PROCESS_ATTACH:
			// create forms on load
			if (AdvConfigForm==NULL)
				{
				// create the advanced config form, persistant through life of plugin
				// ATTN: the dif between these two lines can be the dif between hell and normal exit
				 // Application->CreateForm(__classid(TAdvConfigForm), &AdvConfigForm);
				// AdvConfigForm=new TAdvConfigForm(NULL);
				// ATTN: never tried this yet:
				AdvConfigForm=new TAdvConfigForm(Application);
				}
			break;

		case DLL_PROCESS_DETACH:
			// this should be called by host but we might call it AGAIn here if we wante to be sure
			// that we shutdown and our code is such that there was no harm in calling it twice
			// MyPlugin_DoShutdown();
			break;

		case DLL_THREAD_ATTACH:
			break;

		case DLL_THREAD_DETACH:
			break;
	}

	// success
	return TRUE;
}
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
BOOL MyPlugin_DoInit()
{
	AdvConfigForm->set_basedir(dlldir);

	iconfile=AnsiString(dlldir)+"PopQuotes.ico";

	// load advanced options and init
	AdvConfigForm->DoInitialize();
	//AdvConfigForm->LoadSettings();

	// success
	return TRUE;
}


BOOL MyPlugin_DoShutdown()
{
	// Delete the advanced config form
	if (AdvConfigForm!=NULL)
		{
		// save advanced options? no we save when we change it so not at shutdown
		// AdvConfigForm->SaveSettings();
		}

	if (AdvConfigForm!=NULL)
		{
		// delete the advanced form? no it will be deleted auto when we exit
		//	delete AdvConfigForm;
		//	AdvConfigForm=NULL;
		}

	// ShowMessage("ATTN: In Shutdown!");

	// success
	return TRUE;
}
//-----------------------------------------------------------------------




//-----------------------------------------------------------------------
BOOL MyPlugin_GetStrVal(const char* varname,char *destbuf, int maxlen)
{
	// FARR: default values for FARR fields
	if (strcmp(varname,DEF_FieldName_RegexStr)==0)
		{
		strcpy(destbuf,ThisPlugin_FARR_DefaultRegex);
		return TRUE;
		}
	if (strcmp(varname,DEF_FieldName_RegexFilterStr)==0)
		{
		strcpy(destbuf,ThisPlugin_FARR_DefaultRegexFilter);
		return TRUE;
		}
	if (strcmp(varname,DEF_FieldName_KeywordStr)==0)
		{
		strcpy(destbuf,ThisPlugin_FARR_DefaultKeywordStr);
		return TRUE;
		}
	if (strcmp(varname,DEF_FieldName_ScoreStr)==0)
		{
		strcpy(destbuf,ThisPlugin_FARR_DefaultScoreStr);
		return TRUE;
		}
	if (strcmp(varname,DEF_FieldName_AliasStr)==0)
		{
		strcpy(destbuf,ThisPlugin_FARR_DefaultAlias);
		return TRUE;
		}


	// not found
	return FALSE;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
BOOL MyPlugin_SetStrVal(const char* varname, void *val)
	{
	// farr host will pass us function pointer we will call
	if (strcmp(varname,DEF_FieldName_NotifySearchCallbackFp)==0)
		{
		callbackfp_notifysearchstatechanged = (Fp_GlobalPluginCallback_NotifySearchStateChanged)val;
		return TRUE;
		}

	return FALSE;
	}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
BOOL MyPlugin_SupportCheck(const char* testname, int version)
{
	// ATTN: we support farr interface
	if (strcmp(testname,DEF_FARRAPI_IDENTIFIER)==0)
		return TRUE;

	// otherwise we don't support it
	return FALSE;
}
//-----------------------------------------------------------------------




//-----------------------------------------------------------------------
BOOL MyPlugin_DoAdvConfig()
{
	// Form style?
	bool doshowmodal=false;
	//
	// create it if not created yet
	// ATTN: the dif between these two lines can be the dif between hell and normal exit
	// Application->CreateForm(__classid(TAdvConfigForm), &AdvConfigForm);
	//AdvConfigForm=new TAdvConfigForm(NULL);

	// show modal or just show?
	if (doshowmodal)
		AdvConfigForm->ShowModal();
	else
  		AdvConfigForm->Show();

	// success
	return TRUE;
}


BOOL MyPlugin_DoShowReadMe()
{
	// by default show the configured readme file
	std::string fname = std::string(dlldir)+std::string("\\")+std::string(ThisPlugin_ReadMeFile);
	ShellExecute(NULL, "open", fname.c_str(), NULL,NULL, SW_SHOWNORMAL);
	// success
	return TRUE;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
BOOL MyPlugin_SetState(int newstateval)
{
	// usually there is nothing to do here

	// success
	return TRUE;
}
//-----------------------------------------------------------------------

























//-----------------------------------------------------------------------
// These functions are FARR-SPECIFIC and have no counterparts in the
//  generic DLL shell.
//
// Note from the function declarations that these functions are EXPORTED
//  from the DLL so that the host can call them.
//-----------------------------------------------------------------------




//-----------------------------------------------------------------------
// Host informs us that a search is begining and what the searchstring is
// The Plugin DLL could do all "searching" here (if there is indeed any to do)
// And compute all results within this function, OR simply begin a threaded asynchronous search now.
//
// Normally the string you care about is searchstring_lc_nokeywords, thats the search string with all special +modifier keywords removed, and
//  the alias keyword for this plugin removed, so all thats left is the string that should effect the results of the search.
//
// returns TRUE only if the plugin decides now that no more searching should be done by any other plugin or builtin
//
// NOTE: if asynchronous searching is to be done, make sure to only set current_searchstate=E_SearchState_Stopped when done!
//
PREFUNCDEF BOOL EFuncName_Inform_SearchBeginsV2(const char* searchstring_raw, const char *searchstring_lc_nokeywords, BOOL explicitinvocation, const char* modifierstring, int triggermethod)
{
	// normal search
	return DoFarrSearchBegin(searchstring_lc_nokeywords, triggermethod);
}
//-----------------------------------------------------------------------





//-----------------------------------------------------------------------
// Host informs us that regular expression match **HAS** occured, and to begin doing that we need to do on such a match
// The Plugin DLL could do all "searching" here (if there is indeed any to do)
// And compute all results within this function, OR simply begin a threaded asynchronous search now.
//
// To access the group capture strings, use regexcharps[1] to match the first group, etc.
//
// returns TRUE only if the plugin decides now that no more searching should be done by any other plugin or builtin
//
// NOTE: if asynchronous searching is to be done, make sure to only set current_searchstate=E_SearchState_Stopped when done!
//
PREFUNCDEF BOOL EFuncName_Inform_RegexSearchMatchV2(const char* searchstring_raw, const char *searchstring_lc_nokeywords, int regexgroups, char** regexcharps, const char* modifierstring, int triggermethod)
{
	// doesnt work with regex
	return FALSE;

	// regex match -- regexcharps[1] is our matching pattern $$1 (see header file for what it matches on)
	if (regexgroups==0)
		{
		// no args yet, just show help about
		DoFarrSearchBegin("", triggermethod);
		return FALSE;
		}

	return DoFarrSearchBegin(regexcharps[1], triggermethod);
}
//-----------------------------------------------------------------------





//-----------------------------------------------------------------------
// Host informs us that a search has completed or been interrupted, and we should stop any processing we might be doing assynchronously
//
// NOTE: make sure to set current_searchstate=E_SearchState_Stopped;
//
PREFUNCDEF void EFuncName_Inform_SearchEnds()
{
	// stop search and set this
	current_searchstate=E_SearchState_Stopped;

	// ATTN: test clear results
	numresultsavailable=0;
	resultsavailabletype=E_ResultAvailableState_None;

	// notify host that our state has changed
	ExecuteCallback_SearchStateChanged();

	return;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host informs us that our window is about to appear
PREFUNCDEF void EFuncName_Inform_WindowIsHiding(HWND hwndp)
{
	return;
}


// Host informs us that our window is about to disappear
PREFUNCDEF void EFuncName_Inform_WindowIsUnHiding(HWND hwndp)
{
	return;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host is asking us if we want a certain feature or call
// We should use a switch function here to tell what is being asked
//
// Returns TRUE or FALSE depending on whether we want the feature
//
PREFUNCDEF BOOL EFuncName_Ask_WantFeature(E_WantFeaturesT featureid)
{
	switch (featureid)
		{
		case E_WantFeatures_searchinput_regex:
			// do we want to search on regular expression matches
			return TRUE;
		case E_SupportFeatures_searchinput_explicit:
			// do we want to search on alias match
			return TRUE;
		case E_SupportFeatures_searchinput_all:
			// do we want to search on all search expressions
			return FALSE;
		case E_SupportFeatures_tryhandle_trigger:
			// do we want to try to handle triggers when a result is launched
			return TRUE;
		case E_SupportFeatures_addinfo_files:
			// do we want to try to handle triggers when a result is launched
			return FALSE;
		case E_SupportFeatures_scoreall_files:
			// do we want to try to score EVERY file considered (SLOWS DOWN SEARCH!)
			return FALSE;
		case E_SupportFeatures_scoregood_files:
			// do we want to try to score files after other scoring has determined they are a viable result
			return FALSE;
		case E_SupportFeatures_dominate_results:
			// do we want our results to dominate and hide any others
			return FALSE;
		}

	// fell through - so not supported
	return false;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host wants to know the search state of the plugin
// returns:  E_SearchState_Stopped=0 || E_SearchState_Searching=1
//
// NOTE: this value will be based on a dll global variable
//
PREFUNCDEF E_SearchStateT EFuncName_Ask_SearchState()
{
	// this will be tracked elsewhere
	return current_searchstate;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host wants to know what kind if any results we have available
//
// NOTE: return is from (see JrPluginFuncs_FARR.h) enum E_ResultAvailableStateT { E_ResultAvailableState_None=0, E_ResultAvailableState_ItemResuls=1, E_ResultAvailableState_DisplayText=2, E_ResultAvailableState_DisplayHtml=3, E_ResultAvailableState_Grid=4, E_ResultAvailableState_WinTakeover=5 };
//
PREFUNCDEF E_ResultAvailableStateT EFuncName_Ask_IsAnyResultAvailable()
{
	// this will be tracked elsewhere
	return resultsavailabletype;
}


// Host wants to know how many item results are available
PREFUNCDEF int EFuncName_Ask_HowManyItemResultsAreReady()
{
	// this will be tracked elsewhere
	return numresultsavailable;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host calls this before iterating through the result requests
// It will be TRUE on lock before retrieving
//  and then FALSE when all done retrieving
// In this way the dll should refrain from altering the results until retrieval is done
// One way to do this for asynchronous searching is to MOVE results to a return store
//  on TRUE lock, and then free on FALSE.
//
// Returns TRUE on success
//
PREFUNCDEF BOOL EFuncName_Request_LockResults(BOOL dolock)
{
	// set lock
	current_lockstate=dolock;

	if (dolock==false)
		{
		// on unlocking they have retrieved all the results, so CLEAR the results or they will be found again
		numresultsavailable=0;
		resultsavailabletype=E_ResultAvailableState_None;
		// notify host that our state has changed
		ExecuteCallback_SearchStateChanged();
		}

	// success
	return TRUE;
}
//-----------------------------------------------------------------------




//-----------------------------------------------------------------------
// Host is requesting one of our results
// Fill the destination buffers without exceding maxlen
//
// resultpostprocmodep is from enum E_ResultPostProcessingT { E_ResultPostProcessing_ImmediateDisplay = 0, E_ResultPostProcessing_AddScore = 1, E_ResultPostProcessing_MatchAgainstSearch = 2};
//
// Returns TRUE on success
//
PREFUNCDEF BOOL EFuncName_Request_ItemResultByIndex(int resultindex, char *destbuf_path, char *destbuf_caption, char *destbuf_groupname, char *destbuf_iconfilename, void** tagvoidpp, int maxlen, E_ResultPostProcessingT *resultpostprocmodep, int *scorep, E_EntryTypeT *entrytypep)
{
	// results
	if (false)
		return FALSE;
	static AnsiString pasteprefix=AnsiString("paste ");

	// how result is handled
	// return E_ResultPostProcessing_ImmediateDisplay if we have done the filtering and the result should be displayed
	// return E_ResultPostProcessing_AddScore if the host should evaluate the result and add a score to it but still be forced to display it
	// return E_ResultPostProcessing_MatchAgainstSearch if the host should evaluate the result and decide whether to show it based on match of search words
	//
	// in this case we just return all bookmarks and let host do the matching
	*resultpostprocmodep=E_ResultPostProcessing_MatchAgainstSearch;

	// do we want to modify the score assigned by host?  usually not.
	// *scorep+=100;

	// type (file is same as url)
	*entrytypep=E_EntryType_CLIP;

	// ok fill the result data
	BookStore* bookstorep;
	AnsiString quotestring=AdvConfigForm->GetQuoteByIndex(resultindex, bookstorep);

	if (bookstorep!=NULL)
		{
		// quotestring+=AnsiString(" [")+AnsiString((bookstorep->get_title()).c_str())+"]";
		strncpy(destbuf_path,(pasteprefix+quotestring).c_str(),maxlen);
		strncpy(destbuf_caption,quotestring.c_str(),maxlen);
		strncpy(destbuf_groupname,(bookstorep->get_title()).c_str(),maxlen);
		// record quote #
		*tagvoidpp=(void*)resultindex;
		}
	else
		{
		strncpy(destbuf_path,"",maxlen);
		strncpy(destbuf_caption,"",maxlen);
		strncpy(destbuf_groupname,"",maxlen);
		// record quote #
		*tagvoidpp=(void*)0;
		}
	//
	strncpy(destbuf_iconfilename,iconfile.c_str(),maxlen);



	// ok filled one
	return TRUE;
}
//-----------------------------------------------------------------------




//-----------------------------------------------------------------------
// Host is asking us to return a char* to a LONG result string
//
// NOTE: It is up to us to free this char* when the lock is set to false above OR
//  on the next call, or on search end, but we MUST keep it valid until then.
PREFUNCDEF BOOL EFuncName_Request_TextResultCharp(char **charp)
{
	// signify we have none
	*charp=NULL;

	// none returned
	return FALSE;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host is calling us with a result item about to be triggered
// We can choose here to takeover the launching of it, OR simply do something and let normal launching continue
//
// Return TRUE to takeover launching and prevent all other further launching
// or FALSE to continue launching after we return
//
PREFUNCDEF BOOL EFuncName_Allow_ProcessTrigger(const char* destbuf_path, const char* destbuf_caption, const char* destbuf_groupname, int pluginid, int thispluginid, int score, E_EntryTypeT entrytype, void* tagvoidp, BOOL *closeafterp)
{
	// does this plugin want to take over launching of this result?
	if (pluginid==thispluginid)
		{
		// test alert with result id
		//AnsiString str = "Pasting quote # " + AnsiString((int)tagvoidp);
		//callbackfp_set_strval(hostptr,"DisplayAlertMessage",str.c_str());
		}

	// no
	return FALSE;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host is asking us if we want to modify the score of an item
// Original score in in *score, we can now modify it if we want
//
// Return TRUE if we modified it, or FALSE if not
//
// NOTE: set score to -9999 to eliminate it from results
//
PREFUNCDEF BOOL EFuncName_Do_AdjustResultScore(const char* itempath, int *scorep)
{
	// we didnt modify it
	return FALSE;
}
//-----------------------------------------------------------------------










//-----------------------------------------------------------------------
// Host is telling us about a special key being pressed in memo mode
//  This is called when user presses Enter, plus most alt or control combos, etc
//
PREFUNCDEF BOOL EFuncName_ReceiveKey(int Key, int altpressed, int controlpressed, int shiftpressed)
{
	// we didnt do anything so return FALSE
	AnsiString str = "DEBUGTEST Plugin key pressed." + AnsiString(Key);
	// callbackfp_set_strval(hostptr,"statusbar",str.c_str());


	return FALSE;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
// Host is telling us that the user has remained idle (not typed anything) in some time
//  Typically this gets called every 500ms of idle time.  It is ONLY called when
//  this plugin is controlling the memo output mode and FARR screen is visible
// This can let you make your plugin do live dynamic updating without waiting for user to hit enter, etc.
//  Not this will NOT get called while user is typing quickly, only AFTER they do nothing for a bit.
//
PREFUNCDEF BOOL PluginFunc_IdleTime(int elapsedmilliseconds)
{
	// we didnt do anything so return FALSE
	//AnsiString str = "DEBUGTEST Plugin idle: " + AnsiString(elapsedmilliseconds);
	//callbackfp_set_strval(hostptr,"statusbar",str.c_str());
	return FALSE;
}
//-----------------------------------------------------------------------
















//---------------------------------------------------------------------------
// Helper Functions the plugin calls
//---------------------------------------------------------------------------





//-----------------------------------------------------------------------
void ExecuteCallback_SearchStateChanged()
{
	// tell the host that our state or resultcount has changed
	if (callbackfp_notifysearchstatechanged)
		{
		callbackfp_notifysearchstatechanged(hostptr,numresultsavailable,current_searchstate);
		}
}
//-----------------------------------------------------------------------










































//-----------------------------------------------------------------------
BOOL DoFarrSearchBegin(const char *expressionstring, int triggermethod)
{
	AnsiString expressionstr = AnsiString(expressionstring);
	// fixup
	expressionstr=expressionstr.Trim();
	expressionstr=expressionstr.LowerCase();

	// FARR search -- all we really do is return all bookmarks in our store, and let the farr program filter them based on what user types
	if (!isready)
		{
		// statusbar
		callbackfp_set_strval(hostptr,"statusbar","Plugin is busy..");
		// search can continue by others?
		return FALSE;
		}

	// handle special stuff
	if (HandleSpecialExpressions(expressionstr,triggermethod))
		return TRUE;

	// evaluate expression
	EvaluateAndShow(expressionstr,triggermethod);

	// if triggered with enter key?
	if (triggermethod==1 && strlen(expressionstring)>0)
		{
		// clear search
		//callbackfp_set_strval(hostptr,"setsearch","");
		}
	// search can continue by others?
	return FALSE;
}
//-----------------------------------------------------------------------


//---------------------------------------------------------------------------
bool HandleSpecialExpressions(AnsiString &expressionstr,int triggermethod)
{
	AnsiString ResultAnsiStringStatic;
	if (expressionstr=="`")
		{
		AdvConfigForm->ReScanBookDir();
		}
	if (expressionstr=="`" || expressionstr=="" || expressionstr=="about" || expressionstr=="help")
		{
		ResultAnsiStringStatic=AnsiString(ThisPlugin_DisplayName)+ " - "+AnsiString(ThisPlugin_VersionString)+ " (" +AnsiString(ThisPlugin_ReleaseDateString)+") by "+AnsiString(ThisPlugin_Author)+"\r\n\r\n"+AnsiString(ThisPlugin_About)+"\r\n\r\n";
		ResultAnsiStringStatic+=AnsiString("Quotes loaded and active: ")+AnsiString(AdvConfigForm->GetActiveQuoteCount())+"\r\n\r\n";
		// display using char*
		char *resultbuf=ResultAnsiStringStatic.c_str();
		callbackfp_set_strval(hostptr,"window.richeditmode",resultbuf);
		return TRUE;
		}


	// search cannot continue by others? (return TRUE if not)
	return FALSE;
}
//---------------------------------------------------------------------------













//---------------------------------------------------------------------------
void EvaluateAndShow(AnsiString expressionstr, int triggermethod)
{

	// just return all items
	// start and end of search state
	current_searchstate=E_SearchState_Searching;


	// ok now results are available right away
	numresultsavailable=AdvConfigForm->GetActiveQuoteCount();
	resultsavailabletype=E_ResultAvailableState_ItemResuls;
	// done
	current_searchstate=E_SearchState_Stopped;

	// notify host that our state has changed
	ExecuteCallback_SearchStateChanged();

	return;



	// use static so it stays availabe even past return
	static AnsiString ResultAnsiStringStatic;

	// result
	ResultAnsiStringStatic="";

	// calculate memo info to show here
	ResultAnsiStringStatic="You typed: '"+AnsiString(expressionstr)+"'.";

	// set site
	callbackfp_set_strval(hostptr,"window.richeditheight",(char*)220);
	callbackfp_set_strval(hostptr,"window.richeditwidth",(char*)300);

	// display using char*
	char *resultbuf=ResultAnsiStringStatic.c_str();
	callbackfp_set_strval(hostptr,"window.richeditmode",resultbuf);

	// statusbar
	callbackfp_set_strval(hostptr,"statusbar",ThisPlugin_StatusBar);
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
void CopyToClipboard(AnsiString txt)
{
	// copy text to clipboard
	Clipboard()->SetTextBuf(txt.c_str());
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// string splitters - picks off left or right word of string
bool JrLeftStringSplit(AnsiString &mainstr,AnsiString &leftword, const AnsiString &splitstr, bool dotrim)
{
	int pos;
	if (mainstr=="")
		{
		leftword="";
		return false;
		}
	int splitstrlen=splitstr.Length();

	pos=mainstr.Pos(splitstr);
	if (pos==0)
		{
		if (dotrim)
			leftword=mainstr.Trim();
		else
			leftword=mainstr;
		mainstr="";
		return true;
		}
	if (pos==1)
		leftword="";
	else
		leftword=mainstr.SubString(1,pos-1);
	if (pos==mainstr.Length())
		mainstr="";
	else
		mainstr=mainstr.SubString(pos+splitstrlen,mainstr.Length()-(pos+(splitstrlen-1)));

	if (dotrim)
		{
		leftword=leftword.Trim();
		mainstr=mainstr.Trim();
		}
	return true;
}
//---------------------------------------------------------------------------

