//-----------------------------------------------------------------------
// JrPlugin_MyPlugin
//-----------------------------------------------------------------------


//---------------------------------------------------------------------------
// Header Guard
#ifndef JrPlugin_MyPluginH
#define JrPlugin_MyPluginH
//---------------------------------------------------------------------------



//------------------------------------------------------------------------
// system includes
#include <vcl.h>
#include <windows.h>
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// includes generic plugin shell of other headers
#include "JrPlugin_GenericShell.h"
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// Inlcude FARR SPECIFIC plugin func definitions (shared with host)
#include "JrPluginFuncs_FARR.h"
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
// C++ Builder Stuff
#pragma hdrstop
//-----------------------------------------------------------------------


















//-----------------------------------------------------------------------
// Plugin defines refered to in JrPlugin_GenericShell.cpp
// IMPORTANT: you need to customize there
//
#define ThisPlugin_DisplayName					"BcbSample"
#define ThisPlugin_VersionString				"1.01.01"
#define ThisPlugin_ReleaseDateString		"June 30th, 2008"
#define ThisPlugin_Author								"mouser <mouser@donationcoder.com>"
#define ThisPlugin_HomepageURL					"http://samplebcb.dcmembers.com/samplebcb"
#define ThisPlugin_UpdateURL						""
#define ThisPlugin_ShortDescription			"C++ Builder Sample Plugin"
#define ThisPlugin_LongDescription			"This plugin just shows some basic functinality of FARR plugins using C++ Builder."
#define ThisPlugin_About								ThisPlugin_LongDescription
#define ThisPlugin_StatusBar						"BcbSample plugin by mouser@donationcoder.com"
//
// If you support advanced options button, specify caption here, otherwise ""
#define ThisPlugin_AdvConfigString			"Advanced Options"
//
// If you support a read me file or help file, specify caption here, otherwise ""
#define ThisPlugin_ReadMeString					"View Help File"
// Used internally to display help file
#define ThisPlugin_ReadMeFile						"README.txt"
//
// If this plugin has an icon (recommended), specify icon file in same dir as dll - shown in plugin list
#define ThisPlugin_IconFilename					"BcbSample.ico"
//
//-----------------------------------------------------------------------






















//-----------------------------------------------------------------------
// FARR specific stuff - how its triggered
#define ThisPlugin_FARR_DefaultAlias				""
#define ThisPlugin_FARR_DefaultRegex				"^samp (.*)$|^samp$"
#define ThisPlugin_FARR_DefaultRegexFilter	""
#define ThisPlugin_FARR_DefaultKeywordStr		""
#define ThisPlugin_FARR_DefaultScoreStr			"999"
//-----------------------------------------------------------------------






//-----------------------------------------------------------------------
// external globals defined in the .cpp
extern E_SearchStateT current_searchstate;
extern E_ResultAvailableStateT resultsavailabletype;
extern int numresultsavailable;
extern BOOL current_lockstate;
extern bool isready;
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// FARR: global callback when we want to tell host our search state has changed asynchronously
extern Fp_GlobalPluginCallback_NotifySearchStateChanged callbackfp_notifysearchstatechanged;
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// Forward declarations
void ExecuteCallback_SearchStateChanged();
BOOL DoFarrSearchBegin(const char *expressionstring, int triggermethod);
void EvaluateAndShow(AnsiString expressionstr, int triggermethod);
//-----------------------------------------------------------------------


//-----------------------------------------------------------------------
// Our plugin-specific functions called by generic plugin shell
BOOL MyPlugin_DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved);
//
BOOL MyPlugin_DoInit();
BOOL MyPlugin_DoShutdown();
BOOL MyPlugin_GetStrVal(const char* varname,char *destbuf, int maxlen);
BOOL MyPlugin_SetStrVal(const char* varname, void *val);
BOOL MyPlugin_SupportCheck(const char* testname, int version);
BOOL MyPlugin_DoAdvConfig();
BOOL MyPlugin_DoShowReadMe();
BOOL MyPlugin_SetState(int newstateval);
//-----------------------------------------------------------------------



//---------------------------------------------------------------------------
bool HandleSpecialExpressions(AnsiString &expressionstr, int triggermethod);
void CopyToClipboard(AnsiString txt);
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
bool JrLeftStringSplit(AnsiString &mainstr,AnsiString &leftword, const AnsiString &splitstr, bool dotrim);
//---------------------------------------------------------------------------

//-----------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------


