//---------------------------------------------------------------------------
// AdvConfigFormUnit.cpp
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// System includes and C++ Builder Stuff
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Application includes
#include "JrPlugin_MyPlugin.h"
#include "AdvConfigFormUnit.h"
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// C++ Builder stuff
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Global Form Instance Pointer
TAdvConfigForm *AdvConfigForm=NULL;
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
__fastcall TAdvConfigForm::TAdvConfigForm(TComponent* Owner)
	: TForm(Owner)
{
	// nothing to do in constructor
}
//---------------------------------------------------------------------------


//-----------------------------------------------------------------------
void __fastcall TAdvConfigForm::ButtonOkClick(TObject *Sender)
{
	// save settings
	SaveSettings();
	Close();
}
//---------------------------------------------------------------------------




//-----------------------------------------------------------------------
void __fastcall TAdvConfigForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	// save any manual changes to parser vars? or this is done automatically elsewhere

	// ATTN: we need to hide if we create the form with Application->CreateForm since its main form and wont hide otherwise
	Action=caHide;
	Hide();
}
//---------------------------------------------------------------------------









//-----------------------------------------------------------------------
bool TAdvConfigForm::SaveSettings()
{
	// save adv options to file
	bool bretv=false;
	AnsiString appdir=AnsiString(dlldir);
	AnsiString filename=appdir+"advoptions.cfg";
	AnsiString filenametemp=filename+".tmp";

	// open temp ini file
        TMemIniFile *ini;
        ini = new TMemIniFile(filenametemp);
        if (!ini)
                return false;

	// save settings to temp file
	try
		{
		// save info
		bretv=SaveConfigIni(ini);
		}
	catch (...)
		{
		// MyShowMessage("Error loading "+AnsiString(ThisPlugin_DisplayName)+" plugin configuration file '"+filename+"'.");
		}

	ini->UpdateFile();

	// close ini
	delete ini;

	// ok success, so now copy it over the real existing settings file
	if (bretv && FileExists(filenametemp))
		{
		if (FileExists(filename))
			{
			// make backup
			if (FileExists(filename+".bak"))
				DeleteFile((filename+".bak").c_str());
			CopyFile(filename.c_str(),(filename+".bak").c_str(),true);
			DeleteFile(filename.c_str());
			}
		RenameFile(filenametemp.c_str(),filename.c_str());
		}

	// success
	return bretv;
}


bool TAdvConfigForm::SaveConfigIni(TMemIniFile *ini)
{
	// load ini stuff

	ini->WriteString("Information","File Identification",AnsiString(ThisPlugin_DisplayName));
	ini->WriteString("Information","Version",AnsiString(ThisPlugin_VersionString));


	// success
	return true;
}
//-----------------------------------------------------------------------



//-----------------------------------------------------------------------
bool TAdvConfigForm::LoadSettings()
{
	// load adv options from file
	bool bretv=false;
	AnsiString appdir=AnsiString(dlldir);
	AnsiString filename=appdir+"advoptions.cfg";

	if (!FileExists(filename))
		return false;

        TMemIniFile *ini;
        ini = new TMemIniFile(filename);
        if (!ini)
        	{
		// file not found
                return false;
                }

	// load settings
	try
		{
		// load info
		AnsiString version;
		version=ini->ReadString("Information","File Identification","");
		if (version!=AnsiString(ThisPlugin_DisplayName))
			{
			ShowMessage("Error: "+filename+" is not a configuration file for this plugin. Please delete it if this problem persists.");
			}
		else
			{
			bretv=LoadConfigIni(ini);
			}
		}
	catch (...)
		{
		ShowMessage("Error loading "+AnsiString(ThisPlugin_DisplayName)+" plugin configuration file '"+filename+"'.");
		}

	// close ini
	delete ini;


	// success
	return bretv;
}


bool TAdvConfigForm::LoadConfigIni(TMemIniFile *ini)
{
	// load ini stuff
	AnsiString FileVersion=ini->ReadString("Information","Version","");


	// success
	return true;
}
//-----------------------------------------------------------------------





//-----------------------------------------------------------------------
void TAdvConfigForm::SettingsHaveChanged()
{
	// settings have changed, now deal with it
}
//-----------------------------------------------------------------------












