unit FarrPluginFuncs;

interface
uses
  Windows,
  Sysutils,
//  Dialogs, // (for ShowMessage for testing)
  FarrPluginGlobals,
  MyPlugin;


  function PluginFunc_DoInit(const fullfilename:PChar ; inhostptr:Pointer; const hostname:PChar; const hostversionstring:PChar; incallbackfp_GetStrVal:FP_GetStrVal; incallbackfp_SetStrVal:FP_SetStrVal): BOOL; cdecl;
  function PluginFunc_DoShutDown():BOOL; cdecl;
  function PluginFunc_SupportCheck(const testname:PChar; version:integer):BOOL; cdecl;
  function PluginFunc_SetState(newstateval:E_PluginStateT):BOOL; cdecl;
  function PluginFunc_DoAdvConfig():BOOL; cdecl;
  function PluginFunc_DoShowReadMe():BOOL; cdecl;
  function PluginFunc_GetStrVal(const varname:PChar; destbuf:PChar; maxlen:integer):BOOL; cdecl;
  function PluginFunc_SetStrVal(const varname:PChar; val:Pointer):BOOL; cdecl;

  function PluginFunc_Inform_SearchBegins(const searchstring_raw:PChar; const searchstring_lc_nokeywords:PChar; explicitinvocation:BOOL):BOOL; cdecl;
  function PluginFunc_Inform_RegexSearchMatch(const searchstring_raw:PChar; const searchstring_lc_nokeywords:PChar; regexgroups:integer; regexcharps:P_PCharArray):BOOL; cdecl;
  function PluginFunc_Ask_WantFeature(featureid:E_WantFeaturesT):BOOL; cdecl;
  function PluginFunc_Ask_SearchState():E_SearchStateT; cdecl;
  function PluginFunc_Ask_IsAnyResultAvailable():E_ResultAvailableStateT; cdecl;
  function PluginFunc_Ask_HowManyItemResultsAreReady():integer; cdecl;
  function PluginFunc_Request_LockResults(dolock:BOOL):BOOL; cdecl;
  function PluginFunc_Request_ItemResultByIndex(resultindex:integer; destbuf_path:PChar; destbuf_caption:PChar; destbuf_groupname:PChar; destbuf_iconfilename:PChar; tagvoidpp:PPointer; maxlen:integer; resultpostprocmodep:PE_ResultPostProcessingT; scorep:PInteger; entrytypep:PE_EntryTypeT):BOOL; cdecl;
  function PluginFunc_Request_TextResultCharp(charp:P_PCharArray):BOOL; cdecl;
  function PluginFunc_Allow_ProcessTrigger(const destbuf_path:PChar; const destbuf_caption:PChar; const destbuf_groupname:PChar; pluginid:integer; thispluginid:integer; score:integer; entrytype:E_EntryTypeT; tagvoidp:Pointer; closeafterp:PBOOL):BOOL; cdecl;
  function PluginFunc_Do_AdjustResultScore(const itempath:PChar; scorep:PInteger):BOOL; cdecl;
  function PluginFunc_Do_AddInfo(const itempath:PChar):BOOL; cdecl;

  procedure PluginFunc_Inform_SearchEnds(); cdecl;
  procedure PluginFunc_Inform_WindowIsHiding(hwndp:HWND); cdecl;
  procedure PluginFunc_Inform_WindowIsUnHiding(hwndp:HWND); cdecl;

implementation

  function PluginFunc_DoInit(const fullfilename:PChar ; inhostptr:Pointer; const hostname:PChar; const hostversionstring:PChar; incallbackfp_GetStrVal:FP_GetStrVal; incallbackfp_SetStrVal:FP_SetStrVal): BOOL; cdecl;
  begin
    // Save values for later use
    dlldir := PChar(ExtractFileDir(fullfilename));
    iconfpath := dlldir;

    Host_SetStrVal := incallbackfp_SetStrVal;
    Host_GetStrVal := incallbackfp_GetStrVal;
    hostptr := inhostptr;

	  Result := MyPlugin.DoInit();
  end;

  function PluginFunc_DoShutDown():BOOL; cdecl;
  begin
    Result := MyPlugin.DoShutDown();
  end;

  function PluginFunc_SupportCheck(const testname:PChar; version:integer):BOOL; cdecl;
  begin
    Result := MyPlugin.SupportCheck(testname, version);
  end;

  function PluginFunc_SetState(newstateval:E_PluginStateT):BOOL; cdecl;
  begin
    Result := MyPlugin.SetState(newstateval);
  end;

  function PluginFunc_DoAdvConfig():BOOL; cdecl;
  begin
    Result := MyPlugin.DoAdvConfig();
  end;

  function PluginFunc_DoShowReadMe():BOOL; cdecl;
  begin
    Result := MyPlugin.DoShowReadMe();
  end;


  function PluginFunc_GetStrVal(const varname:PChar; destbuf:PChar; maxlen:integer):BOOL; cdecl;
  begin
    Result := MyPlugin.GetStrVal(varname,destbuf,maxlen);
  end;

  function PluginFunc_SetStrVal(const varname:PChar; val:Pointer):BOOL; cdecl;
  begin
    Result := MyPlugin.SetStrVal(varname,val);
  end;

  function PluginFunc_Inform_SearchBegins(const searchstring_raw:PChar; const searchstring_lc_nokeywords:PChar; explicitinvocation:BOOL):BOOL; cdecl;
  begin
    Result := MyPlugin.InformSearchBegins(searchstring_raw, searchstring_lc_nokeywords,explicitinvocation);
  end;

  function PluginFunc_Inform_RegexSearchMatch(const searchstring_raw:PChar; const searchstring_lc_nokeywords:PChar; regexgroups:integer; regexcharps:P_PCharArray):BOOL; cdecl;
  begin
    Result := MyPlugin.InformRegexSearchMatch(searchstring_raw,searchstring_lc_nokeywords,regexgroups,regexcharps);
  end;

  function PluginFunc_Ask_WantFeature(featureid:E_WantFeaturesT):BOOL; cdecl;
  begin
    Result := MyPlugin.AskWantFeature(featureid);
  end;

  function PluginFunc_Ask_SearchState():E_SearchStateT; cdecl;
  begin
    Result := MyPlugin.AskSearchState();
  end;

  function PluginFunc_Ask_IsAnyResultAvailable():E_ResultAvailableStateT; cdecl;
  begin
    Result := MyPlugin.AskIsAnyResultAvailable();
  end;

  function PluginFunc_Ask_HowManyItemResultsAreReady():integer; cdecl;
  begin
    Result := MyPlugin.AskHowManyItemResultsAreReady();
  end;

  function PluginFunc_Request_LockResults(dolock:BOOL):BOOL; cdecl;
  begin
    Result := MyPlugin.RequestLockResults(dolock);
  end;

  function PluginFunc_Request_ItemResultByIndex(resultindex:integer; destbuf_path:PChar; destbuf_caption:PChar; destbuf_groupname:PChar; destbuf_iconfilename:PChar; tagvoidpp:PPointer; maxlen:integer; resultpostprocmodep:PE_ResultPostProcessingT; scorep:PInteger; entrytypep:PE_EntryTypeT):BOOL; cdecl;
  begin
    Result := MyPlugin.RequestItemResultByIndex(resultindex,destbuf_path,destbuf_caption,destbuf_groupname,destbuf_iconfilename,tagvoidpp,maxlen,resultpostprocmodep,scorep,entrytypep);
  end;

  function PluginFunc_Request_TextResultCharp(charp:P_PCharArray):BOOL; cdecl;
  begin
    Result := MyPlugin.RequesttextResultCharp(charp);
  end;

  function PluginFunc_Allow_ProcessTrigger(const destbuf_path:PChar; const destbuf_caption:PChar; const destbuf_groupname:PChar; pluginid:integer; thispluginid:integer; score:integer; entrytype:E_EntryTypeT; tagvoidp:Pointer; closeafterp:PBOOL):BOOL; cdecl;
  begin
    Result := MyPlugin.AllowProcessTrigger(destbuf_path,destbuf_caption,destbuf_groupname,pluginid,thispluginid,score,entrytype,tagvoidp,closeafterp);
  end;

  function PluginFunc_Do_AdjustResultScore(const itempath:PChar; scorep:PInteger):BOOL; cdecl;
  begin
    Result := MyPlugin.DoAdjustResultScore(itempath,scorep);
  end;

  function PluginFunc_Do_AddInfo(const itempath:PChar):BOOL; cdecl;
  begin
    Result := MyPlugin.DoAddInfo(itempath);
  end;

  procedure PluginFunc_Inform_SearchEnds(); cdecl;
  begin
    MyPlugin.InformSearchEnds();
  end;

  procedure PluginFunc_Inform_WindowIsHiding(hwndp:HWND); cdecl;
  begin
    MyPlugin.InformWindowIsHiding(hwndp);
  end;

  procedure PluginFunc_Inform_WindowIsUnHiding(hwndp:HWND); cdecl;
  begin
    MyPlugin.InformWindowIsUnhiding(hwndp);
  end;

end.
