unit FarrPluginGlobals;

interface
  uses
    IniFiles,
    Windows;

  type
    // Enums
    E_PluginStateT = (E_PluginState_Disabled=0, E_PluginState_Enabled=1, E_PluginState_dummybig=79000);
    E_WantFeaturesT = (E_WantFeatures_searchinput_regex=0, E_SupportFeatures_searchinput_explicit=1, E_SupportFeatures_searchinput_all=2, E_SupportFeatures_tryhandle_trigger=3, E_SupportFeatures_addinfo_files=4, E_SupportFeatures_scoreall_files=5, E_SupportFeatures_scoregood_files=6, E_SupportFeatures_dominate_results=7 , E_SupportFeatures_dummybig=79000);
    E_SearchStateT = (E_SearchState_Stopped=0, E_SearchState_Searching=1  , E_SearchState_dummybig=79000);
    E_ResultAvailableStateT = (E_ResultAvailableState_None=0, E_ResultAvailableState_ItemResults=1, E_ResultAvailableState_DisplayText=2, E_ResultAvailableState_DisplayHtml=3, E_ResultAvailableState_Grid=4, E_ResultAvailableState_WinTakeover=5 , E_ResultAvailableState_dummybig=79000);
    E_ResultPostProcessingT = (E_ResultPostProcessing_ImmediateDisplay = 0, E_ResultPostProcessing_AddScore = 1, E_ResultPostProcessing_MatchAgainstSearch = 2 , E_ResultPostProcessing_dummybig=79000);
    E_EntryTypeT = (E_EntryType_UNKNOWN=0, E_EntryType_FILE=1, E_EntryType_FOLDER=2, E_EntryType_ALIAS=3, E_EntryType_URL=4  , E_EntryType_PLUGIN=5, E_EntryType_dummybig=79000);

    PE_ResultPostProcessingT = ^E_ResultPostProcessingT;
    PE_EntryTypeT = ^E_EntryTypeT;
    // Function pointers
    Fp_GetStrVal = function(JrPluginPointerp:Pointer; varname:PChar; destbuf:PChar; maxlen:integer):BOOL; cdecl;
    Fp_SetStrVal = function(JrPluginPointerp:Pointer; varname:PChar; strbuf:PChar):BOOL; cdecl;
    Fp_NotifySearchStateChanged = procedure(JrPluginPointerp:Pointer; newresultcount:integer; newstate:E_SearchStateT); cdecl;
    Fp_UpdateProgress = procedure(JrPluginPointerp:Pointer; progresspercent:integer);cdecl;

    T_PCharArray = array[0..High(Integer) div SizeOf(PChar)-1] of PChar;
    P_PCharArray = ^T_PCharArray;

  const
    DEF_StandardMaxStrLen:integer = 1024;
    DEF_FieldName_DisplayName:string = 'displayname';
    DEF_FieldName_VersionString:string = 'versionstring';
    DEF_FieldName_ReleaseDateString:string = 'releasedatestring';
    DEF_FieldName_Author:string = 'author';
    DEF_FieldName_HomepageURL:string = 'homepageurl';
    DEF_FieldName_UpdateURL:string = 'updateurl';
    DEF_FieldName_ShortDescription:string = 'shortdescription';
    DEF_FieldName_LongDescription:string = 'longdescription';
    DEF_FieldName_AdvConfigString:string = 'advconfigstring';
    DEF_FieldName_ReadMeString:string = 'readmestring';
    DEF_FieldName_IconFilename:string = 'iconfilename';
    DEF_FieldName_AliasStr: string = 'aliasstr';
    DEF_FieldName_RegexStr:string	= 'regexstr';
    DEF_FieldName_RegexFilterStr:string =	'regexfilterstr';
    DEF_FieldName_KeywordStr:string	= 'keywordstr';
    DEF_FieldName_ScoreStr:string	= 'scorestr';
    DEF_FieldName_NotifySearchCallbackFp:string =	'notifysearchcallback';
    DEF_FieldName_EnterInRichEdit:string = 'enterinrichedit';
    DEF_FieldName_DefaultSearchText:string = 'defaultsearchtext';
    DEF_GRABRESULTS_MAXLEN:integer = 512;
    DEF_FARRAPI_IDENTIFIER:string = 'farrapi';

  var
    // Global variables
    Host_GetStrVal:Fp_GetStrVal = NIL;
    Host_SetStrVal:Fp_SetStrVal = NIL;
    Host_NotifySearchStateChanged:Fp_NotifySearchStateChanged = NIL;
    hostptr:Pointer = NIL;
    lockstate:BOOL;
    isready:BOOL = True;
    numresultsavailable:integer = 0;
    dlldir:string;
    iconfpath:string;
    searchstate: E_SearchStateT = E_SearchState_Stopped;
    resultsavailabletype: E_ResultAvailableStateT = E_ResultAvailableState_None;
    pluginstate: E_PluginStateT;
    results:array of string = NIL;
    inifile:TIniFile;
    // Specifically for Locate32 plugin, you can modify this
    locateexelocation:string;
    locatemaxfoundfiles:integer = 50;

implementation

end.
