#include <windows.h>
#include "resource.h"

BOOL CALLBACK MainDlgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	UNREFERENCED_PARAMETER(lParam);
	switch(uMsg) {
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case WM_INITDIALOG:
				{
					SendDlgItemMessage(hWnd, IDC_EDIT, EM_LIMITTEXT, 1024, 0);
				}
				break;
				case IDC_OK:
				{
					HANDLE hMapping, hMutex, hEvent;
					LPSTR lpString;
					if ((hMutex = OpenMutex(MUTEX_MODIFY_STATE, FALSE, "FARR_EXTERNALSEARCH_ACTIVE")) != NULL)
					{
						CloseHandle(hMutex);
						hMapping = OpenFileMapping(FILE_MAP_WRITE, FALSE, "FARR_EXTERNALSEARCH_SEARCH_STRING");
						lpString = (CHAR *)MapViewOfFile(hMapping,FILE_MAP_WRITE,0,0,1024);
						GetDlgItemText(hWnd, IDC_EDIT, lpString, 1024);
						hEvent = OpenEvent(EVENT_MODIFY_STATE, FALSE, "FARR_EXTERNALSEARCH_PERFORM_SEARCH");
						SetEvent(hEvent);
						UnmapViewOfFile(lpString);
						CloseHandle(hMapping);
					}
					else
					{
						MessageBox(hWnd, "FARR ExternalSearch is not active.", NULL, MB_OK);
					}
					
				}
				break;
				case IDC_EXIT:
				{
					SendMessage(hWnd, WM_CLOSE, 0, 0);
				}
				break;
			}
		break;
		case WM_CLOSE:
		{
			EndDialog(hWnd, 0);
			PostQuitMessage(0);
		}
		break;
	}
	return FALSE;
}


BOOL WINAPI EntryPoint(void)
{
	MSG msg;
	HWND hWnd;
	HINSTANCE hInstance = GetModuleHandle(0);
	hWnd = CreateDialogParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)MainDlgProc, 0);
	while(GetMessage(&msg,NULL,0,0)==TRUE)
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	} 
	return FALSE;
}


