// OptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OptionDlg.h"
#include "prefs.h"

// COptionDlg dialog

// The normal HANDLE_MSG macro in WindowsX.h does not work properly for dialog
// boxes because DlgProc return a BOOL instead of an LRESULT (like
// WndProcs). This chHANDLE_DLGMSG macro corrects the problem:
#define chHANDLE_DLGMSG(hwnd, message, fn)                 \
   case (message): return (SetDlgMsgResult(hwnd, uMsg,     \
   HANDLE_##message((hwnd), (wParam), (lParam), (fn))))

///////////////////////////////////////////////////////////////////////////////


BOOL Dlg_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam) {

  // chSETDLGICONS(hwnd, IDI_ERRORSHOW);
  
  TCHAR buf[MAX_PATH+1] = {0};
  
  GetOption(_T("SETUP"), _T("LeaveOpenAfterLaunch"), _T("TRUE"), buf, MAX_PATH);
  bool bLeaveOpenAfterLaunch = (_tcsicmp(buf, _T("TRUE")) == 0);
  CheckDlgButton(hwnd, IDC_CHECK1, bLeaveOpenAfterLaunch ? BST_CHECKED : BST_UNCHECKED );    

  GetOption(_T("SETUP"), _T("LaunchAction"), LP_PREFS_LA_SET_DEFAULT, buf, MAX_PATH);
  if (_tcsicmp(buf,LP_PREFS_LA_SET_DEFAULT) == 0)
  {
    CheckRadioButton (hwnd, IDC_RADIO1, IDC_RADIO2, IDC_RADIO1);
  }
  else
  {
    CheckRadioButton (hwnd, IDC_RADIO1, IDC_RADIO2, IDC_RADIO2) ;
  }  

/*
  HWND hwndOwner; 
  RECT rc, rcDlg, rcOwner; 

  // Get the owner window and dialog box rectangles. 
  if ((hwndOwner = GetParent(hwnd)) == NULL) 
  {
    hwndOwner = GetDesktopWindow(); 
  }

  GetWindowRect(hwndOwner, &rcOwner); 
  GetWindowRect(hwnd, &rcDlg); 
  CopyRect(&rc, &rcOwner); 

  // Offset the owner and dialog box rectangles so that right and bottom 
  // values represent the width and height, and then offset the owner again 
  // to discard space taken up by the dialog box. 
  OffsetRect(&rcDlg, -rcDlg.left, -rcDlg.top); 
  OffsetRect(&rc, -rc.left, -rc.top); 
  OffsetRect(&rc, -rcDlg.right, -rcDlg.bottom); 

  // The new position is the sum of half the remaining space and the owner's 
  // original position. 

  SetWindowPos(hwnd, 
    HWND_TOP, 
    rcOwner.left + (rc.right / 2), 
    rcOwner.top + (rc.bottom / 2), 
    0, 0,          // Ignores size arguments. 
    SWP_NOSIZE);
*/
  return(TRUE);
}


///////////////////////////////////////////////////////////////////////////////


void Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify) {

  switch (id) 
  {
  case IDOK:        
    SetOption(_T("SETUP"), _T("LeaveOpenAfterLaunch"), (IsDlgButtonChecked(hwnd, IDC_CHECK1) == BST_CHECKED) ? _T("TRUE") : _T("FALSE"));
    SetOption(_T("SETUP"), _T("LaunchAction"), (IsDlgButtonChecked(hwnd, IDC_RADIO1) == BST_CHECKED) ? LP_PREFS_LA_SET_DEFAULT : LP_PREFS_LA_OPEN_PRINTER);
    EndDialog(hwnd, id);
    break;

  case IDCANCEL:    
    EndDialog(hwnd, id);
    break;   
  }
}


///////////////////////////////////////////////////////////////////////////////


INT_PTR WINAPI Dlg_Proc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
{
  switch (uMsg) 
  {
    chHANDLE_DLGMSG(hwnd, WM_INITDIALOG, Dlg_OnInitDialog);
    chHANDLE_DLGMSG(hwnd, WM_COMMAND,    Dlg_OnCommand);   
  }
  return(FALSE);  
}


