/**************************************************************************

File:          Printers.h

Description:   

**************************************************************************/
#ifndef LIST_PRINTER_PRINTERS_H
#define LIST_PRINTER_PRINTERS_H

#include "shellapi.h"
#include <shlobj.h>

typedef BOOL (*LPENUMITEMS)(LPCTSTR, LPARAM);

#include <vector>
using namespace std;

struct FarrPrinter
{
  TCHAR printerName[MAX_PATH+1];
  TCHAR printerFriendlyName[MAX_PATH+1];
  TCHAR menuText[MAX_PATH+1];
  TCHAR helpText[MAX_PATH+1];
  bool  bIsDefault;  
};

typedef std::vector<FarrPrinter> FarrPrinterList;
typedef std::vector<FarrPrinter>::iterator FarrPrinterListIter;

#ifdef __cplusplus
extern "C" {
#endif

  HRESULT InstallPrinter(LPTSTR, LPTSTR);
  BOOL OpenPrinterProperties(LPCTSTR);
  void EnumPrinterItems(FarrPrinterList* pList);
  BOOL CreatePrinterShortcut(LPTSTR, LPTSTR);
  BOOL OpenThisPrinter(LPCTSTR);
  BOOL CreateAddPrinter(LPTSTR);
  BOOL ExecuteAddPrinter(void);
  BOOL CreateAddPrinterShortcut(LPTSTR);
  BOOL DPGetDefaultPrinter(LPTSTR pPrinterName, LPDWORD pdwBufferSize);
  BOOL DPSetDefaultPrinter(LPTSTR pPrinterName);

#ifdef __cplusplus
}
#endif

#endif // #define LIST_PRINTER_PRINTERS_H