// OptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OptionDlg.h"
#include "prefs.h"
#include "commctrl.h"

// COptionDlg dialog

// The normal HANDLE_MSG macro in WindowsX.h does not work properly for dialog
// boxes because DlgProc return a BOOL instead of an LRESULT (like
// WndProcs). This chHANDLE_DLGMSG macro corrects the problem:
#define chHANDLE_DLGMSG(hwnd, message, fn)                 \
   case (message): return (SetDlgMsgResult(hwnd, uMsg,     \
   HANDLE_##message((hwnd), (wParam), (lParam), (fn))))

///////////////////////////////////////////////////////////////////////////////


BOOL Dlg_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam) 
{
  TCHAR buf[MAX_PATH+1] = {0};

  GetOption(_T("SETUP"), _T("ConfirmBeforeTerminate"), _T("TRUE"), buf, MAX_PATH);
  bool bConfirmBeforeTerminate = (_tcsicmp(buf, _T("TRUE")) == 0);
  CheckDlgButton(hwnd, IDC_CHECK1, bConfirmBeforeTerminate ? BST_CHECKED : BST_UNCHECKED ); 

  GetOption(_T("SETUP"), _T("ExtractIcons"), _T("TRUE"), buf, MAX_PATH);
  bool bExtractIcons = (_tcsicmp(buf, _T("TRUE")) == 0);
  CheckDlgButton(hwnd, IDC_CHECK2, bExtractIcons ? BST_CHECKED : BST_UNCHECKED ); 

  GetOption(_T("SETUP"), _T("ShowProgress"), _T("TRUE"), buf, MAX_PATH);
  bool bShowProgress = (_tcsicmp(buf, _T("TRUE")) == 0);
  CheckDlgButton(hwnd, IDC_CHECK3, bShowProgress ? BST_CHECKED : BST_UNCHECKED ); 

  GetOption(_T("SETUP"), _T("TimeoutBeforeTerminate"), _T("3"), buf, MAX_PATH);
  DWORD dwTimeout = _ttoi(buf);
  if (dwTimeout < 0) dwTimeout = 0;
  if (dwTimeout > 60) dwTimeout = 60;
  SetDlgItemInt(hwnd, IDC_EDIT1, dwTimeout, false);

  SendMessage(GetDlgItem(hwnd, IDC_SPIN1), UDM_SETRANGE32, 0, MAKELONG(60, 0));
  
  return(TRUE);
}


///////////////////////////////////////////////////////////////////////////////


void Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify) 
{
  TCHAR buf[MAX_PATH+1] = {0};
  switch (id) 
  {
  case IDOK:    
    // check for empty value
    if (!GetDlgItemText(hwnd, IDC_EDIT1, buf, MAX_PATH)) return;

    SetOption(_T("SETUP"), _T("ConfirmBeforeTerminate"), (IsDlgButtonChecked(hwnd, IDC_CHECK1) == BST_CHECKED) ? _T("TRUE") : _T("FALSE"));
    SetOption(_T("SETUP"), _T("ExtractIcons"), (IsDlgButtonChecked(hwnd, IDC_CHECK2) == BST_CHECKED) ? _T("TRUE") : _T("FALSE"));
    SetOption(_T("SETUP"), _T("ShowProgress"), (IsDlgButtonChecked(hwnd, IDC_CHECK3) == BST_CHECKED) ? _T("TRUE") : _T("FALSE"));        
    SetOption(_T("SETUP"), _T("TimeoutBeforeTerminate"), buf);

    EndDialog(hwnd, id);
    break;

  case IDCANCEL:
    EndDialog(hwnd, id);
    break;   
  }
}


///////////////////////////////////////////////////////////////////////////////


INT_PTR WINAPI Dlg_Proc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
{
  switch (uMsg) 
  {
    chHANDLE_DLGMSG(hwnd, WM_INITDIALOG, Dlg_OnInitDialog);
    chHANDLE_DLGMSG(hwnd, WM_COMMAND,    Dlg_OnCommand);   
  }
  return(FALSE);  
}


