#pragma once

#include <windows.h>
#include <windowsx.h>

#include "resource.h"

class CProgressDlg
{
public:
  CProgressDlg(TCHAR* title = NULL) : m_hEvent1(NULL), m_hEvent2(NULL), m_hDlgWnd(NULL), m_threadHandle(NULL)
  {
    ZeroMemory((void*)m_Title, MAX_PATH);
    if (title) _tcsncpy(m_Title, title, MAX_PATH);

    m_hEvent1 = CreateEvent(NULL, false, false, NULL);  // wait for this event to indicate UI is ready
    m_hEvent2 = CreateEvent(NULL, false, false, NULL);  // set this event to dismiss UI
  }

  ~CProgressDlg()
  {
    Dismiss();
    if (m_hEvent1) CloseHandle(m_hEvent1);
    if (m_hEvent2) CloseHandle(m_hEvent2);
  }

  void Show();
  void Dismiss();

  static unsigned __stdcall TShowProgress(void* pvargs);

protected:
  void   ShowProgress();
  TCHAR  m_Title[MAX_PATH+1];
  HANDLE m_hEvent1;
  HANDLE m_hEvent2;
  HWND   m_hDlgWnd;
  uintptr_t m_threadHandle;
};

INT_PTR WINAPI ProgressDlg_Proc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);