// OptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OptionDlg.h"
#include "prefs.h"

// COptionDlg dialog

// The normal HANDLE_MSG macro in WindowsX.h does not work properly for dialog
// boxes because DlgProc return a BOOL instead of an LRESULT (like
// WndProcs). This chHANDLE_DLGMSG macro corrects the problem:
#define chHANDLE_DLGMSG(hwnd, message, fn)                 \
   case (message): return (SetDlgMsgResult(hwnd, uMsg,     \
   HANDLE_##message((hwnd), (wParam), (lParam), (fn))))

///////////////////////////////////////////////////////////////////////////////


BOOL Dlg_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam) 
{
  TCHAR buf[MAX_PATH+1] = {0};

  GetOption(_T("SETUP"), _T("ShowMsgBoxSuccess"), _T("FALSE"), buf, MAX_PATH);
  bool bShowMsgBoxSuccess = (_tcsicmp(buf, _T("TRUE")) == 0);
  CheckDlgButton(hwnd, IDC_CHECK1, bShowMsgBoxSuccess ? BST_CHECKED : BST_UNCHECKED ); 

  GetOption(_T("SETUP"), _T("ShowMsgBoxError"), _T("TRUE"), buf, MAX_PATH);
  bool bShowMsgBoxError = (_tcsicmp(buf, _T("TRUE")) == 0);
  CheckDlgButton(hwnd, IDC_CHECK2, bShowMsgBoxError ? BST_CHECKED : BST_UNCHECKED ); 

  GetOption(_T("SETUP"), _T("ShowProgress"), _T("TRUE"), buf, MAX_PATH);
  bool bShowUI = (_tcsicmp(buf, _T("TRUE")) == 0);
  CheckDlgButton(hwnd, IDC_CHECK3, bShowUI ? BST_CHECKED : BST_UNCHECKED ); 

  return(TRUE);
}


///////////////////////////////////////////////////////////////////////////////


void Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify) 
{
  switch (id) 
  {
  case IDOK: 
    SetOption(_T("SETUP"), _T("ShowMsgBoxSuccess"), (IsDlgButtonChecked(hwnd, IDC_CHECK1) == BST_CHECKED) ? _T("TRUE") : _T("FALSE"));
    SetOption(_T("SETUP"), _T("ShowMsgBoxError"), (IsDlgButtonChecked(hwnd, IDC_CHECK2) == BST_CHECKED) ? _T("TRUE") : _T("FALSE"));
    SetOption(_T("SETUP"), _T("ShowProgress"), (IsDlgButtonChecked(hwnd, IDC_CHECK3) == BST_CHECKED) ? _T("TRUE") : _T("FALSE"));    
    EndDialog(hwnd, id);
    break;

  case IDCANCEL:
    EndDialog(hwnd, id);
    break;   
  }
}


///////////////////////////////////////////////////////////////////////////////


INT_PTR WINAPI Dlg_Proc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
{
  switch (uMsg) 
  {
    chHANDLE_DLGMSG(hwnd, WM_INITDIALOG, Dlg_OnInitDialog);
    chHANDLE_DLGMSG(hwnd, WM_COMMAND,    Dlg_OnCommand);   
  }
  return(FALSE);  
}


