// ServiceCtrlHelper.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <windows.h>

#include <atlbase.h>
#include <atlconv.h>
#include <ShellAPI.h>

#include "ServiceCtrlHelper.h"

// progress bar (http://www.codeproject.com/miscctrl/nonprogressbar.asp)
#include "..\ServiceCtrl\GSControls.h"

typedef void (CALLBACK *pFuncServiceCtl)(const TCHAR* svcName, const TCHAR* svcDisplayName, bool bStart);

// Global Variables:
HINSTANCE hInst;								// current instance

int APIENTRY _tWinMain(HINSTANCE hInstance,
                       HINSTANCE hPrevInstance,
                       LPTSTR    lpCmdLine,
                       int       nCmdShow)
{
  UNREFERENCED_PARAMETER(hPrevInstance);
  UNREFERENCED_PARAMETER(lpCmdLine);

  USES_CONVERSION;

  LPWSTR *szArglist;
  int nArgs;  

  szArglist = CommandLineToArgvW(GetCommandLineW(), &nArgs);

  if (szArglist)
  {
    if (nArgs < 4)
    {
      LocalFree(szArglist);
    }

    // initialize progress bar
    INITCOMMONCONTROLSEX InitCtrlEx;
    InitCtrlEx.dwSize = sizeof(INITCOMMONCONTROLSEX);
    InitCtrlEx.dwICC  = ICC_PROGRESS_CLASS;
    InitCommonControlsEx(&InitCtrlEx);
    InitializeGSControls();

    const TCHAR* svcName = W2T(szArglist[1]);
    const TCHAR* svcDisplayName = W2T(szArglist[2]);
    const TCHAR* svcOp = W2T(szArglist[3]);
    bool bStart = (_tcsicmp(svcOp, _T("start")) == 0);

    pFuncServiceCtl pFn = NULL;
    HMODULE hDLL = LoadLibrary(_T("ServiceCtrlPlugin.dll"));
    if (hDLL)
    {
      pFn = (pFuncServiceCtl)GetProcAddress(hDLL, "_ServiceCtrl@12");
      if (pFn)
      {
        pFn(svcName, svcDisplayName, bStart);
      }
      FreeLibrary(hDLL);
    }
    LocalFree(szArglist);
  }

  UninitializeGSControls();

  return 1;
}
